package fitconnect.impl.auth;

import de.fitko.fitconnect.api.domain.auth.OAuthToken;
import de.fitko.fitconnect.api.services.Sender;
import de.fitko.fitconnect.core.SubmissionSender;
import de.fitko.fitconnect.core.auth.DefaultOAuthService;
import org.junit.jupiter.api.Test;
import org.springframework.web.client.RestTemplate;

import java.util.Optional;

import static org.junit.jupiter.api.Assertions.*;

class OAuthTokenIntegrationTest {

    @Test
    void retrieveAuthenticationToken() {

        // Given
        var tokenUrl = "https://auth-testing.fit-connect.fitko.dev/token";
        var clientId = "781f6213-0f0f-4a79-9372-e7187ffda98b";
        var secret = "PnzR8Vbmhpv_VwTkT34wponqXWK8WBm-LADlryYdV4o";
        var scope1 = "send:region:DE";
        var scope2 = "send:region:EN";

        var authService = new DefaultOAuthService( new RestTemplate(), tokenUrl);
        final Sender sender = new SubmissionSender(authService, null, null, null);

        // When
        Optional<OAuthToken> token = sender.retrieveOAuthToken(clientId, secret, scope1,scope2);

        // Then
        assertTrue(token.isPresent());
        assertNull(token.get().getError());
        assertNotNull(token.get().getAccessToken());
        assertEquals(1800, token.get().getExpiresIn());
    }
}